
Bookmarks
==============

* [uv](https://docs.astral.sh/uv/concepts/tools/#tools-directory)
* [click](https://click.palletsprojects.com/en/stable/options/#multiple-options)


Previous notes
================

When expecting an image... to enforce mime, or at least not then follow HTML

EXAMPLE:

http://www.getmiro.com/img/i/shot1.png

http://metavid.ucsc.edu/images/interface.jpg

DONE:
Extra checks before recursively following text/html response
Ensure that we are expecting a local .html



13 Dec 2024
==============



Start from webarchiving script, as is.

Use on some test cases (try working with a "universal" function).


* Mapping URL to (local) path
* Defining inside/outside


reasons to localize

currently:
       (elt.tag in ["img", "video", "audio", "script"] and
           attribname == "src" and not self.has_exception(href)) or \
        (elt.tag == "link" and elt.attrib.get("rel") == "stylesheet") or \
        ((elt.tag == "a" or attribname in additional_attributes) and
            self.has_local_path(href))


reasons to not localize (exceptions)


DESIRE: to add plugins for special types of things like
* Mediawiki (to use API to make "nice" HTML)
* Etherpad (use export API to make text+html(+...))

TODO: change core patterns to be functions, remove/replace "post-processing" function.

create RegExPattern (class?, or just a function)

Following example of schaarbeeksetaal... consider how a search and replace could be built into the transform.

Build a spider dryrun function to test. 

* How to use for "simple" wget like (single page) requests...

Testing on diversions... I see that external links need to be absolutized.

Seeing it work now, desire to change the default rewriting to *use paths* and hashes *only when necessary*. ALSO, it would be super nice if the default rewriting worked with hostnames so that mixing in other sites would work well (maybe this should be an option ?!).

ISSUE: Fragments are stripped off of external links.


Feb 2025
=================

Old-style spider command (from webarchiving.py)

    selvage spider \
        --output-path diversions \
        --pattern "^https://diversions.constantvzw.org/wiki/$" "index.html" \
        https://diversions.constantvzw.org/wiki/


The desire is to follow/support a logic of browsers' "save as... (HTML only)" and "save as... (web archive)"...

Currently the default behaviour of:

    selvage spider URL

with no patterns is to save the page in a folder named with the hostname (index.html as default name), with all dependencies left external (so as in HTML-only). So, does it make sense to add a flag that would pull in required / referenced resources, even when *not* matching a pattern.

Already this would be quite interesting if one could manually selvage multiple URLs with their results potentially interlinking (but you would need to rewrite links ?!).

    selvage spider https://vj12.constantvzw.org

outputs:

    https://vj12.constantvzw.org => ./vj12.constantvzw.org/index.html


Thinking how the sequence:

    selvage spider https://vj12.constantvzw.org
    selvage spider https://vj12.constantvzw.org/about/

could draw pieces together.

Follow a "git-repo" style (and indeed do in a way compatible with eventual use with git), of an init command to start a selvage (in the current directory).

Then commands can be aware of the archive that they are currently in, so in the command above, the first page would have links that would be external, but the about could already link to the home page (as it's *known* to the archive), and there should be a command to *reweave* the links (ie for all html pages, check links and rewrite external links that point to internal/known resources).

Rather than "spider" the command would make a lot of sense if it were simply "add" again following git. (Spider is then maybe an option on add).

This then would allow a very simple model of use by explicitly adding resources to determine the "range" of the archive without needing to define patterns (meaning working with exceptions becomes very easy).

<!> Then "simply" adding glob style patterns to the add command would be very powerful.

<!> The add command should support an optional output path. In the case of a glob pattern, this output could then make use of replacement variables (as in the current add pattern).

It would be very interesting to have several "maintenance" commands to check on the *status* of the archive (again following git, *status*). It would be very interesting to see statistics like number of HTML pages, numbers of links, of which how many internal / external. Eventually commands like checking the status of external links might be useful.

So in sum:

* spider => add
* support patterns in add URL
* optional output path (evt also with pattern/replacement variables)
* flag for "web archive" style archiving whereby referenced/included resources are automatically imported/added (embedded media, stylesheets, fonts).
* selvage add, maintains patterns in a settings file (using yaml?!... or maybe json is better?)

Suggestive then of a *pull* (or fetch) command that would re-sync the local archive with the remote (live) pages. Imagining also a plugin for use with wayback!

Also imagining outputs of a selvage archive to say
* EPUB
* PDF
* static HTML (eventually with versions)

And features like:
* Metadata stored as RDF!

A key idea is the separate the original snapshot of a URL from its subsequent rewriting as (say) a localized copy with relativized links. In this way you satisfy the archival requirement to keep originals, while allowing the rewriting to be repeatable (using different methods / outputs).

Discovered [msgspec](https://jcristharif.com/msgspec/) today, thanks to [this blog post](https://tomaugspurger.net/posts/serializing-dataclasses/), as alternative to using just dataclasses (which fail when trying to parse back nested objects), and as seemingly a lighter/faster alternative to pydantic.

BUT... still a desire to use files where possible, including for the initial / original HTTP Response.
HOW to do this, save in a file, using a universal naming scheme, then commiting to git (and thus hashing the content), then allowing for a renaming to a more convenient working file layout.

[GitPython](https://gitpython.readthedocs.io/en/stable/tutorial.html#understanding-objects)


