from dataclasses import dataclass
import msgspec
import enum
from datetime import datetime
from typing import Optional


class PatternType(enum.Enum):
    GLOB = '1'
    REGEX = '2'

# it's still a bit new to me
# https://docs.python.org/3/library/dataclasses.html
#
# @dataclass
# class InventoryItem:
#     """Class for keeping track of an item in inventory."""
#     name: str
#     unit_price: float
#     quantity_on_hand: int = 0

#     def total_cost(self) -> float:
#         return self.unit_price * self.quantity_on_hand

class ResourcePattern (msgspec.Struct):
    """ a (glob or regex) style pattern that matches a set of Resources """
    pattern: str
    pattern_type: PatternType

class Resource(msgspec.Struct):
    url: str
    output_path: Optional[str] = None

class HTTPResponse (msgspec.Struct):
    resource: Resource
    code: int
    content_type: str
    encoding: str
    size: int
    time: datetime
    file: Optional[str] = None

# class TextResponse (msgspec.Struct):
#     body: str
#     hash: str

# class HTMLPage (TextResponse):
#     pass
