from xml.etree import ElementTree as ET
import re


def innerHTML(elt):
    if elt.text != None:
        ret = elt.text
    else:
        ret = ""
    return ret + "".join(
        [ET.tostring(x, method="html", encoding="unicode") for x in elt]
    )


def setInnerHTML(elt, text):
    contents = list(elt)
    for c in contents:
        elt.remove(c)
    elt.text = text


def split_fragment(href):
    try:
        ri = href.rindex("#")
        return href[:ri], href[ri:]
    except ValueError:
        return href, ""


def split_query(href):
    try:
        ri = href.rindex("?")
        return href[:ri], href[ri:]
    except ValueError:
        return href, ""


class NoException(Exception):
    pass


def srcset_sub(val, repl):
    print(f"srset_sub {val}")
    ret = ""
    parts = re.split("(, *)", val)
    i = 0
    while i < len(parts):
        if i % 2 == 0:
            sret = ""
            sparts = re.split("( +)", parts[i])
            j = 0
            while j < len(sparts):
                if j == 0:
                    print(f"srcset sub {i},{j} {sparts[j]}")
                    sret += repl(sparts[j])
                else:
                    sret += sparts[j]
                j += 1
            ret += sret
        else:
            ret += parts[i]
        i += 1
    return ret
